!-----------------------------------------------------------------------------
! Magic and Fight System --- Follower system
! For INFORM compiler and Z-Machine text based Adventure games
!-----------------------------------------------------------------------------
!  Author: Giancarlo Niccolai
!  Version: 1.3
!  Last Revised: 2002-11-26
!  Contact author at:
!  Feel free to use and distribute this file, but please report me if
!  you intend to change it (in better), so we can upgrade together
!
!  Released under GPL 2.0, or any later version at your will
!
!-----------------------------------------------------------------------------
! A simple mean to create a friendly or hostile follower that can follow the
! player on request or by its own initiative
!------------------------------------------------------------------------------

Ifndef Follower;

ifndef pron;
   include "MFS_pronouns";
endif;
Ifndef RoomOf;
   include "MFS_Global";
Endif;


Object FollowDemon
with
   daemon [ obj;

      objectloop(obj provides who_follow ) {
         if (obj.who_follow == 0) continue;
         if (roomOf(obj.who_follow) ~= roomOf (obj) )
            obj.follow_notify(roomof(obj.who_follow));
      }

];


! a follower will follow the player (if required to)
class Follower
   with

   will_follow 0,
   fturns 0,
   who_follow,

   follow_ok_msg[tg;
      print (The) self, " segue senz'altro ",
         (ytpacc) tg, "!^";],

   follow_no_msg[tg;
      print (The) self, " non ha intenzione di seguire ",
         (ytpacc) tg ,".^";
   ],

   stop_ok_message [;
      "~Far@`o come desideri.~";
   ],

   stop_no_message [;
      print (The) self, " non ti ascolta.";
   ],

   start_follow [ who;
      self.who_follow = who;
      self.fturns = 1;
   ],

   stop_follow [;
      self.fturns = 0;
      self.who_follow = 0;
   ],

   follow_message [;
      self.fturns = self.fturns +1;
      if (~~TestScope(self)) return;
      print "^", (The) self;
      if ( self.who_follow == player ) {
         print " ti ";
      }
      if ( self has pluralname)
         print "hanno ";
      else
         print "ha ";
      print "seguito";

      if ( self.who_follow ~= player ) {
         print (ytpacc) self.who_follow;
      }
      print ", e ora ";

      if ( self has pluralname )
         print "sono";
      else
         print "@`e";

      print " qui.^";
   ],

   stop [;
      if (self.will_follow) {
         self.stop_ok_message();
         self.stop_follow();
      }
      else self.stop_no_message();
   ],

   follow_notify[loc;
      move self to loc;
      self.follow_message();
   ],

   orders [;
      FollowMe:
         if (self.who_follow == player) {
            print (The) self, " sta";
            if (self has pluralname) print "nno";
            print " gi@`a seguendo ", (ytpacc) player,".^";
            rtrue;
         }

         if (self.will_follow > 0) {
            self.follow_ok_msg(player);
            self.start_follow(player);
         }
         else {
            self.follow_no_msg(player);
         }
      rtrue; !handled

      Follow:
         if (self.who_follow == noun) {
            print (The) self, " sta gi@`a seguendo ", (ytpacc) noun;
            rtrue;
         }

         if (self.will_follow > 0) {
            self.follow_ok_msg(noun);
            self.start_follow(noun);
         }
         else {
            self.follow_no_msg(noun);
         }
      rtrue; !handled

      Stay:
         self.stop();
      rtrue;
   ],
   has animate;


[FollowSub;
   if (noun hasnt animate)
      "Perdere del tempo seguendo ", (itorthem) noun," non ti sar@`a di aiuto.";
   else
      "Vai per un po' in giro seguendo ", (the) noun, " ma ti stanchi subito.^";
   return AfterRoutines();
];

[FollowMeSub;
   noun = player;
   <<Follow player>>;
];

[StaySub;
   if (actor == player)
      print (string)
         random("Stai gi@`a fermo sui tuoi piedi.", "Facile."), "^";
   return AfterRoutines();
];

Endif;

