!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! MOVECLASS_IT, una libreria che prevede movimenti random, prestabiliti e
!            "intelligenti" per NPC (personaggi non giocanti)
!
! Version 8.10, scritta da Neil Brown          neil@highmount.demon.co.uk
!                        e Alan Trewartha      alan@alant.demon.co.uk
!               con modifiche Glulx di Matthew T. Russotto 13 March 2001
!		tradotta ed adattata all'italiano da Marco Falcinelli Agosto 2006
!
! Ultimo aggiornamento Agosto 2006.
!
! Le funzioni di questa libreria sono troppo complesse per essere spiegate qui, 
! fate riferimento al breve manuale distribuito assieme a aquesto file con il 
! nome di 'moveman_it.txt'.
!
! Se state includendo la libreria FOLLOWER.H nel vostro codice, fate attenzione
! ad includere questo file dopo di essa e non prima, altrimenti otterrete un errore.
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


System_file;
! Righe necessarie per il corretto funzionamento del compilatore Inform 6.21.
  #ifndef WORDSIZE;
  Constant TARGET_ZCODE;
  Constant WORDSIZE 2;
  #endif;

                                     ! Propriet degli NPC:
Property before_action;              ! Eseguita prima di muoversi.
Property after_action;               ! Eseguita dopo che ci si  spostati con successo.
Property caprice alias time_left;    ! Probabilit di spostarsi quando lo spostamento  random.

Property npc_open;                   ! Una propriet per le porte

Global path_size_limit = 10;         ! Profondit della ricerca del percorso

Constant   RANDOM_MOVE = 0;          ! I possibili tipi di movimento move_types
Constant    AIMED_MOVE = 1;
Constant       NO_MOVE = 2;
Constant   PRESET_MOVE = 3;

Constant      ANY_PATH = $$00000000; ! I differenti tipi di spostamenti concessi AIMED_MOVE.
Constant UNLOCKED_PATH = $$00001000; ! Sono Bitmap in modo che possano essere combinati tra loro
Constant     OPEN_PATH = $$00010000; ! in linea di principio
Constant DOORLESS_PATH = $$00100000;

!Ifndef Room;
  Class Room with link_data 0 0 0;
!EndIf;

#ifdef TARGET_ZCODE;
 Class MTR_npcdirclass
  with npc_dirs 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
                        ! Le direzioni calcolate che l'NPC prende.
                        ! Nota questa  una word array, ma le direzioni sono registrate come
                        ! single bytes, cos  possibile un sentiero di 64 movimenti.
#ifnot; !TARGET_GLULX
 Class MTR_npcdirclass
  with npc_dirs 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0;
                        ! L'assunto che una direzione sara un numero intero piuttosto piccolo
                        ! (byte-sized) non  vero in Glulx
                        ! Comunque, Glulx permette propriet grandi, cos non dobbiamo
                        ! preoccuparci.  --MTR
#endif;



Class moveclass
 class MTR_npcdirclass
  with move_type
           RANDOM_MOVE, ! Il movimento previsto di default (move_type)  quello random
       caprice      20, ! possibilit dell'NPC di muoversi ad ogni turno di movimento RANDOM_MOVE
       prepath_name  0, ! Il nome del percorso prestabilito in una array
       prepath_size  0, ! La lunghezza del percorso prestabilito
       npc_stage     0, ! Posizione lungo il percorso prestabilito nell'array
       npc_target,      ! L'obiettivo destinazione
       npc_blocked [; NPC_Path(self,RANDOM_MOVE); ], 
			!Se bloccato si muove a caso
                        ! Come alternativa si pu personalizzare in modo che non fa nulla e aspetta
			! il percorso per sbloccarsi.
                        ! O, pi intelligentemente cercare un percorso meno restrittivo.
       npc_ifblocked 0, ! Propriet utile e liberamente utilizzabile per npc bloccati (npc_blocked)
       npc_arrived [; NPC_Path(self,RANDOM_MOVE); ],
                        ! Ridefinite questa all'interno dell'attuale oggetto NPC 
                        ! per un risultati pi sofisticati. Serve a definire cosa accade
                        ! quando un NPC arriva alla propria destinazione. In
                        ! questo caso, ritorna a muoversi a caso.
       walkoff "si allontana",
       walkon  "arriva",
       follow_action,   ! } Nel caso in cui Follower  stato incluso ma l'NPC
       follow_object,   ! } non  della classe FollowClass.
       daemon [ i n k;
           if (RunRoutines(self,before_action)) rtrue;

           switch(self.move_type)
           { 0, RANDOM_MOVE:                          ! Movimento Random
#ifdef DEBUG;
if (parser_trace>1)
print "[RANDOM_MOVE daemon per ", (the) self ,"]^";
#endif;
              if (random(100)>self.caprice) rfalse;
              objectloop (i in compass)
                if (LeadsTo(i,parent(self),ANY_PATH))
                {  n++;
#ifdef DEBUG;
if (parser_trace>1)
print "[Scelte ",n, ": ",(GiveDir) i ,"]^";
#endif;
                }
              if (n==0) rfalse;
              k=random(n); n=0;                       ! Scegli una direzione
#ifdef DEBUG;
if (parser_trace>1)
print "[Sceglie ",k, "]^";
#endif;
              objectloop (i in compass)
              { if (LeadsTo(i,parent(self),ANY_PATH)) n++;
                if (n==k)
                {  MoveNPCDir(self,i);
                   break;
                }
              }

             1, AIMED_MOVE :                   ! Muovendosi su un percorso calcolato
#ifdef TARGET_ZCODE;
              i=self.&npc_dirs->self.npc_stage;
#ifnot; ! TARGET_GLULX
              i=self.&npc_dirs-->self.npc_stage;
#endif; ! TARGET

#ifdef DEBUG;
if (parser_trace>1)
print "[AIMED_MOVE daemon sposta ", (the) self, " verso ", (GiveDir) i,"]^";
#endif;
              if (i==0  || MoveNPCDir(self,i)) ! Routine chiamata solo se i~=0
                  self.npc_stage++;
              if (parent(self)==self.npc_target)
                  self.npc_arrived();

             2, NO_MOVE :                                ! Non muoversi
#ifdef DEBUG;
if (parser_trace>1)
print "[NO_MOVE daemon per ", (the) self, " non fa niente]^";
#endif;

             3, PRESET_MOVE :               ! Muovendosi su un percorso prestabilito
#ifdef TARGET_ZCODE;
              i=(self.prepath_name)->self.npc_stage;
#ifnot; ! TARGET_GLULX
              i=(self.prepath_name)-->self.npc_stage;
#endif; ! TARGET

#ifdef DEBUG;
if (parser_trace>1)
print "[PRESET_MOVE daemon sposta ", (the) self," verso ", (GiveDir) i, "]^";
#endif;
              if (i==0 ||MoveNPCDir(self,i))   ! Routine chiamata solo se i~=0
                  self.npc_stage++;
              if (self.npc_stage>=self.prepath_size)
                  self.npc_arrived();

       default: "** MoveClass Error: move_type  impostato a un valore non accettabile
                                     per ", (the) self, " **";
          }
        ];



[ NPC_path npc   movement_type targetroom path_type
           steps last_room     found      i j k;

  if (metaclass(movement_type)==Object && movement_type ofclass Room)
  {   path_type=targetroom;
      targetroom=movement_type;
      movement_type=AIMED_MOVE;            ! Per mantenere la compatibilit con codice vecchio
  }
#ifdef DEBUG;
if (parser_trace>1)
{print "^[NPC_Path imposta ", (the) self," su ";
 switch (movement_type)
 {     NO_MOVE: print "NO_MOVE";
   RANDOM_MOVE: print "RANDOM_MOVE";
   PRESET_MOVE: print "PRESET_MOVE";
    AIMED_MOVE: print "AIMED_MOVE verso ", (name) targetroom;
       default: print "**INDEFINITO**";
 }
 print "]^";
}
#endif;

  if (~~(npc ofclass moveclass))
  { print "*** MoveClass Error: chiamata NPC_path per un oggetto non appartenente a moveclass '",
           (the) npc, "' ***";
    rfalse;
  }

  if (movement_type==NO_MOVE)              ! Chiamata per impostare NO_MOVE
  {  npc.move_type=NO_MOVE;
     rtrue;
  }

  if (movement_type==RANDOM_MOVE)          ! Chiamata per impostare RANDOM_MOVE
  {  npc.move_type=RANDOM_MOVE;
     if (path_type~=0)
         npc.caprice=path_type;
     rtrue;
  }

  if (movement_type==PRESET_MOVE)          ! Chiamata per impostare PRESET_MOVE
     return NPCprepath(npc,targetroom,path_type);

  if (movement_type~=AIMED_MOVE)
     rfalse;

! VZEFH check
  if (parent(npc)==0)
  { print "^*** MoveClas Error: NPC_path  stata chiamata per l'oggetto '",
           (the)npc, "' che ha parent==0 ***";
    rfalse;
  }

  if (~~(parent(npc) ofclass Room))
     rfalse;


  ! link_data-->0  la LOCAZIONE precedente nella lista cercata di collegamenti di locazione
  ! link_data-->1  il passo precedente (STEP) nel possibile percorso
  ! link_data-->2  la precedente STEP_DIR lungo il possibile percorso

  last_room=parent(npc);        ! Tutte le locazioni cercate sono linkate in una lista
  last_room.&link_data-->0=0;   ! a cominciare dall'ultima locazione 'last_room' andando indietro
  last_room.&link_data-->1=-1;  ! lungo il link_room di ogni locazione.

  if (last_room==targetroom)
  { found=true;                 ! Permette la propriet npc_arrived per avviare
    steps=0;                    ! un'azione se l'npc arriva in una certa locazione
    npc.&npc_dirs-->0=0;
  }
  else
  { for (steps=1: steps<path_size_limit:steps++)
    { i=last_room;                       ! Comincia alla fine della lista
      while (i ~= 0)
      { objectloop (j in Compass)        ! Esplora tutte le direzioni
        { k=LeadsTo(j,i,path_type);
          if (k ofclass Room &&
              k.&link_data-->1==0)       ! Scegli solo 'Room's con un 0 STEP
          { k.&link_data-->1=i;          ! Aggiungi tali locazioni come uno STEP on from 'i'
            k.&link_data-->2=j;          ! Registra le direzioni prese per arrivare li
            k.&link_data-->0=last_room;  ! Aggiungi questa locazione alla lista di collegamenti
            last_room=k;
            if (k==targetroom) found=true;
#Ifdef DEBUG;
if (parser_trace>1) print "[Trovato: ",(name) k, "]^";
#Endif;
          }
          if (found) break;
        }
        if (found) break;
        if (i.&link_data-->0==i.&link_data-->1)
          i=0;                           ! Se link_data STEP = ROOM allora le
        else                             ! rimanenti locazioni sulla lista di collegamenti
          i=i.&link_data-->0;            ! sono gi state esplorate e possiamo
      }                                  ! terminare questa interazione.
      if (found) break;
    }
  }

  if (found)
  { npc.move_type=AIMED_MOVE;            ! Imposta NPC a AIMED_MOVE
    npc.npc_target=targetroom;           ! e riempilo di tutti i dettagli
    npc.prepath_size=steps;
    npc.npc_stage=0;
#ifdef DEBUG;
if (parser_trace>1)
print "[Path ha ",steps, " passi...^";
#endif;
    i=last_room;                         ! Ora torniamo alla fine della lista
    while (i.&link_data-->1~=-1)
    {
#ifdef DEBUG;
if (parser_trace>1)
print (name) i,"  ", (GiveDir) i.&link_data-->2, " di...^";
#endif;

#ifdef TARGET_ZCODE;
      npc.&npc_dirs->(steps-1)=i.&link_data-->2;
#ifnot; ! TARGET_GLULX
      npc.&npc_dirs-->(steps-1)=i.&link_data-->2;
#endif; ! TARGET

      steps--;                           ! Scrivi le npc_dirs con le STEP_DIRs
      i=i.&link_data-->1;                ! E torna lungo gli STEPs

    }
#ifdef DEBUG;
if (parser_trace>1)
print "dove cominciamo!]^";
#endif;
  }
#Ifdef DEBUG;
if(parser_trace>1 && found==false) print "[Percorso non trovato!]^";
#Endif;

  while (last_room~=0)
  {
#ifdef DEBUG;
if (parser_trace>4)
{print "[",(name) last_room," = ";
 print (object) last_room.&link_data-->0, ", ";
 print (object) last_room.&link_data-->1, ", ";
 print (object) last_room.&link_data-->2, "]^";
}
#endif;
     last_room.&link_data-->1=0;           ! Torna indietro lungo la lista di collegamenti
     last_room=last_room.&link_data-->0;   ! resettando i STEP data. Solo le
  }                                        ! Locazioni con 0 STEP sono aggiunte alla lista
                                           ! di collegamenti (vedi sopra)
  return found;
];



[ NPCPrePath npc path_array path_length fakevar;
  fakevar=fakevar;            ! nel caso il codice tenti di passare anche un nome di locazione
  if (npc ofclass moveclass)
  { npc.npc_stage=0;
    npc.move_type=PRESET_MOVE;
    npc.prepath_name=path_array;
    npc.prepath_size=path_length;
  }
  else
  { "*** MoveClass Error: NPCPrePath  stata chiamata per un oggetto non appartenente a moveclass: '",
     (the) npc, "' ***";
  }
];

Ifndef NOISY_DIR_TOS;
Message "** MoveClass::LeadsTo assume silenziosamente *_to (NOISY_DIR_TOS non definito) **";
Endif;

[ LeadsTo direction thisroom path_type k tmp tmp2;
#ifdef DEBUG;
   if (parser_trace>2)
     print "[LeadsTo ", (name)direction, " ", (name)thisroom, "]^";
#endif;

   if (~~(direction provides door_dir)) rfalse;
   if (~~(thisroom provides direction.door_dir)) rfalse;
   k=thisroom.(direction.door_dir);

   #ifdef NOISY_DIR_TOS;
     if (ZRegion(k)==2) rfalse;
   #endif;

   #ifndef NOISY_DIR_TOS;
     if (ZRegion(k)==2)
         k=RunRoutines(thisroom, direction.door_dir);
   #endif;

   if (ZRegion(k)~=1) rfalse;
   if (k has door)
   { if (path_type & DOORLESS_PATH) rfalse;
     if ((path_type & OPEN_PATH) && k hasnt open) rfalse;
     if ((path_type & UNLOCKED_PATH) && k has locked) rfalse;
     tmp=parent(k);
     move k to thisroom;
     tmp2=k.door_to();
     if (tmp==0) remove k; else move k to tmp;
     k=tmp2;
   }
   if (~~(k ofclass Room)) rfalse;
   return k;
];



[ MoveNpcDir npc direction i j p message;
  message=2;
  p=parent(npc);
  i=LeadsTo(direction,p, ANY_PATH);
  if (i==0)
  { npc.npc_blocked();
#ifdef DEBUG;
if (parser_trace>1)
print "[MoveNPCDir bloccato: La Direzione non porta in nessun posto]^";
#endif;
    rfalse;
  }

  j=p.(direction.door_dir);
  if (ZRegion(j)==2) j=j();
  if (j has door)
  { if (j provides npc_open)          ! npc_open restituisce
    { message=j.npc_open(npc);        ! 2 per attraversare come al solito le porte
      if (message==false)             ! 1 per attraversare la porta e prevenire la stampa/esecusione di
      { npc.npc_blocked();            !      walkon/walkoff run/printing
#ifdef DEBUG;                         ! 0 per fermare un npc usando la porta
if (parser_trace>1)
print "[MoveNPCDir bloccato: la npc_open di ", (the) j, " ha restituito false]^";
#endif;
        rfalse;
      }
    }
    else
      if (j hasnt open)
      {   npc.npc_blocked();
#ifdef DEBUG;
if (parser_trace>1)
print "[MoveNPCDir bloccato: ", (the) j, " non ha nessuna npc_open]^";
#endif;
          rfalse;
      }
  }

  MoveNPC(npc, i, ##Go, direction);

  if (p==location && message==2)      ! Se viene usato npc_open allora deve ritornare return 2
  { if (ZRegion(npc.walkoff)==3)      ! se si vuole che siano esegubili walkon/walkoff
        print "^", (The) npc, " ", (string) npc.walkoff,
              " ", (GiveDir) direction, ".^";
    else
        npc.walkoff(direction);
  }

  if (parent(npc)==location && message==2)
  { if (ZRegion(npc.walkon)==3)
      print "^", (The) npc, " ", (string) npc.walkon, ".^";
    else
      npc.walkon(direction);
  }

  if (npc provides after_action) npc.after_action();
  rtrue;
];



Ifndef MoveNPC; ! Provede MoveNPC se il gioco non include 'Follower.h'
[ MoveNPC npc dest actn objn;
  move npc to dest;
  actn=actn;
  objn=objn;
];
Endif;



[ GiveDir i;
  switch(i)
  { n_obj: print "a nord";
    s_obj: print "a sud";
    e_obj: print "a est";
    w_obj: print "a ovest";
    ne_obj: print "a nord-est";
    nw_obj: print "a nord-ovest";
    se_obj: print "a sud-est";
    sw_obj: print "a sud-ovest";
    u_obj: print "su";
    d_obj: print "giu";
   in_obj: print "dentro";
  out_obj: print "fuori";
  }
];
