! ============================================================================ !
!   Scanner_it.h  Uno scanner di prossimit (di classi)
! ============================================================================ !
!   Versione   :  v1.0 dicembre 2004
!
!   Autore/i   :  Alessandro Schillaci e Paolo Lucchesi
!
!   Descrizione:  Una classe che implementa uno scanner: tramite questa libreria,
!                  possibile elencare tutte le "istanze" di una classe presenti
!                 all'interno delle locazioni adiacenti alla locazione attuale
!                 senza spostarsi "fisicamente"
!
!   Licenza    :  Scanner_it.h is free software; you can redistribute it and/or
!                 modify it under the terms of the GNU General Public License
!                 as published by the Free Software Foundation; either version
!                 2 of the License, or (at your option) any later version.
!
!                 flagsit.h is distributed in the hope that it will be useful,
!                 but WITHOUT ANY WARRANTY; without even the implied warranty
!                 of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!                 See the GNU General Public License for more details.
!
!                 You should have received a copy of the GNU General Public
!                 License along with this program; if not, write to the Free
!                 Software Foundation, Inc., 59 Temple Place - Suite 330,
!                 Boston, MA  02111-1307, USA.
! ============================================================================ !
!
!     Uso      :
!
!     1- Aggiungere la linea
!           Include "Scanner_it";
!        nel vostro sorgente, DOPO la riga che include "Parser"
!
!     2- Aggiungere un nuovo verbo in questo modo:
!
!        Verb 'scanner'   				*        -> 	Scan; 
!
!        [ ScanSub;
!	          print  "Attivi lo scanner.......scansione in corso......";
!	          searchnear(NPC);
!        ];
!
!     3- Gli oggetti che devono essere rilevati dallo scanner devono
!        possedere una propriet "remotedesc". In caso contrario, viene
!        visualizzata la loro descrizione
!
! ============================================================================ !
! NOTE:     E' possibile personalizzare il verbo scanner, in modo che reagisca
!           e "cerchi" oggetti di tipo diverso (Per esempio potrebbe essere utile
!           la creazione di uno scanner sensibile alle persone e agli oggetti 
!           inanimati, oppure a particolari classi di oggetti.)
!           E' utile quando il giocatore voglia conoscere il contenuto di una
!           locazione adiacente *SENZA* entrarci fisicamente.
! ============================================================================ !
message "Compiling scanner_it.h (v1.0)";

[Searchroom clss rm x;
    objectloop (x in rm) {
        if (x ofclass clss) {
            if (x provides remotedesc) x.remotedesc();
            else if (x provides description) x.description();
            else print "Puoi vedere ", (a) x, ".^";
        }
    }
];

[Searchnear clazz room i dest desttype;
    ! Trovo la locazione attuale
    room = location;
    while (parent(room)) room = parent(room);

    ! Esploro le locazioni adiacenti
    objectloop (i in compass) {
        dest = room.(i.door_dir);
        if (dest) {
            desttype = ZRegion(dest);
            if ((desttype ~= 3) &&
                (desttype == 2 || dest hasnt door || dest hasnt concealed)) {
                print "^";
                PrintDirectionName(i);
                print " (", (name) dest,")^";

                ! Qui viene lanciata la funzione Searchroom che esplora la room attuale
                ! cercando la classe "clazz"
                Searchroom (clazz,dest);
            }
        }
    }

];

[ PrintDirectionName obj;
    switch (obj) {
	        n_obj:   print "a nord";
	        s_obj:   print "a sud";
	        e_obj:   print "a est";
	        w_obj:   print "ad ovest";
	        ne_obj:  print "a nordest";
	        se_obj:  print "a sudest";
	        nw_obj:  print "a nordovest";
	        sw_obj:  print "a sudovest";
	        u_obj:   print "su";
	        d_obj:   print "gi";
	        in_obj:  print "dentro";
	        out_obj: print "fuori";
	        default: print "direzione non specificata";
        }
];


