! tutor.h, In-Game Suggestions extension
!          Paolo Lucchesi, 2003
!
! ----------------------------------------------------------------------------
!
! To use the tutor:
!   - Put the < Include "tutor"; > command just after < Include "verblib"; >
!
!   - After < Include "grammar.h"; > add the following line
!         Verb meta 'tutor' * -> Tutor;
!
!   - Define a Tutor function with a single argument, that will print the
!     suggestions depending on the number passed as argument. If the routine
!     returns true, the suggestions related to that number won't be shown
!     again thereafter
!
!   - Call the function DoTutor(<number>) to print suggestions related 
!     to <number>
!
!   - Otherwise, call the function DoTutor(<num>, <string>) to print the
!     suggestion string <string>, without defining the Tutor function.
!     Further calls with the same number will be ignored.
!
! ----------------------------------------------------------------------------
!
! This file is free software, it can be freely used, copied, distributed and
! modified. Every source distribution of this file, modified or not, should
! acknoledge the original author, and should be as free as the original.
! There's no such condition for compiled games using this library.
! This file is distributed AS IS, without warranty of any kind. The author 
! isn't liable for any direct or indirect damage due to the proper or improper 
! use of this software. 
!
! ----------------------------------------------------------------------------

Array tflag->32;
Global tutorflag=true;

[ DoTutor num str i j p;
    if (~~tutorflag) rfalse;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    if (tflag->i & p) rfalse;
    style underline;
    print "^";
    if (str>0)   { 
        print (string) str; 
        tflag->i = (tflag->i | p);
    }
    else        
        if (Tutor(num)) tflag->i = (tflag->i | p);
    ! print num, ", ", i, ", ", p, ", ", tflag->i; !
    print "^";
    style roman;
    rtrue;
];

[ asktflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    if (tflag->i & p) rtrue;
    rfalse;
];
    
[ settflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    tflag->i = (tflag->i | p);
    rtrue;
];

[ resettflag num i j p;
    if (num>255) rfalse;
    i = num / 8;
    j = num % 8;
    p = twopower(j);
    p = ((~p) & 255);
    tflag->i = (tflag->i & p);
    rtrue;
];

[ twopower a;
    switch(a) {
    0:  return $$000000001;
    1:  return $$000000010;
    2:  return $$000000100;
    3:  return $$000001000;
    4:  return $$000010000;
    5:  return $$000100000;
    6:  return $$001000000;
    7:  return $$010000000;
    }
    return(0);
];

[ tutordothfake;
    DoTutor();
    asktflag();
    settflag();
    resettflag();
    tutordothfake();
];
    

[TutorSub;
    if (tutorflag) {
        tutorflag = false;
        "[Tutor is now turned off.]";
    }
    tutorflag = true;
    "[Tutor is now turned on.]";
];
